<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Carerapp extends CI_Controller {

	  function __construct() {
        parent::__construct();
        $this->load->helper('url_helper');
        $this->load->model('carer_model');
        $this->load->library("pagination");
        $this->load->helper('form');
        $this->load->library('form_validation');

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/user_guide/general/urls.html
	 */

	  if($this->session->userdata('role_id') == 1) {
            $this->session->set_flashdata('message2', 'You don\'t have access!');
            redirect('welcome/index1');
        }
		
        if(empty($this->session->userdata('id'))) {
            $this->session->set_flashdata('message2', 'You don\'t have access!');
            redirect('');
        }

     }


	public function index()
	{
		$this->load->view('pagesapp/header');
		$this->load->view('carerapp/index');
		$this->load->view('pagesapp/footer');
	}

    public function todayschedule()
    {
        $data['schedules'] = $this->carer_model->get_todayschedules();
        $data['value4'] = $this->carer_model->get_alltimecarers();
        $this->load->view('pagesapp/header');
        $this->load->view('carerapp/todayschedule',$data);
        $this->load->view('pagesapp/footer');
    }

	public function schedule()
	{
		$data['schedules'] = $this->carer_model->get_allschedules();
        $data['value4'] = $this->carer_model->get_alltimecarers();
		$this->load->view('pagesapp/header');
		$this->load->view('carerapp/schedule',$data);
		$this->load->view('pagesapp/footer');
	}

	public function get_scheduleinfo($id,$schedule_id)
	{
		$data['schedule_timein'] = $this->carer_model->get_allschedulestime($id,$schedule_id);
		$data['actual_timein'] = $this->carer_model->get_allschedulestimein($id,$schedule_id);
		$data['actual_timeout'] = $this->carer_model->get_allschedulestimeout($id,$schedule_id);
		$data['tasks'] = $this->carer_model->get_alltasks($id,$schedule_id);
        $data['completed_tasks'] = $this->carer_model->get_all_completedtasks($id,$schedule_id);
		$data['schedule'] = $this->carer_model->get_schedulestatus($id,$schedule_id);
		$this->load->view('pagesapp/header1');
		$this->load->view('carerapp/schedule_info',$data);
		$this->load->view('pagesapp/footer');
	}

	public function finishtask($taskid,$id,$schedule_id)
           {

            	$started =  $this->carer_model->checkif_started1($taskid,$id,$schedule_id);

            	$status = $started['status'];


            	if($status == 0){

                      $this->session->set_flashdata('message1', 'Sorry!..Please Start your task to proceed..');
                      redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
            	}else{
            	    
            	    $this->carer_model->finishtask($taskid,$id,$schedule_id);
                 
                    $saved = $this->carer_model->checkif_completedtask($taskid,$id,$schedule_id);

                    //var_dump($saved); exit();
                    
                    if( $saved == 0){
                         $this->carer_model->save_taskdone($taskid,$id,$schedule_id);
                         $this->session->set_flashdata('message', 'Task Completed successfuly..');
                         redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
                     }else{

                         $this->session->set_flashdata('message1', 'Task Already Completed..');
                         redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
                     }

             }
           }

    public function starttask($id,$schedule_id)
           {

            $schedule_status = $this->carer_model->schedule_status($id,$schedule_id);

            if($schedule_status == 1){
                 $this->session->set_flashdata('message1', 'Task already started..Please Proceed');
                      redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
            }else{

                 $this->carer_model->starttask($id,$schedule_id);
                 $this->carer_model->set_carer($id,$schedule_id);
                 $this->carer_model->save_carertime($id,$schedule_id);
                 $this->session->set_flashdata('message', 'Schedule Started successfuly..');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
             }

           }       

    public function completetask()
           {

                $id = $_POST['id'];
                $schedule_id = $_POST['schedule_id'];
                $notes = $_POST['notes'];
                $incidences = $_POST['incidences'];
                $given_medication = $_POST['given_medication'];
                $medication_policy = $_POST['medication_policy'];

           	    $started =  $this->carer_model->checkif_started($id,$schedule_id);

            	$status = $started['status'];


            if($status == 0){

                      $this->session->set_flashdata('message1', 'Sorry!..Please Start your task to proceed..');
                      redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);

            }else{

                 $this->carer_model->completetask($id,$schedule_id,$notes,$incidences,$given_medication,$medication_policy);
                 $this->carer_model->updatestatus($id,$schedule_id,$notes,$incidences,$given_medication,$medication_policy);
                 $this->session->set_flashdata('message', 'Schedule Completed successfuly..');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);

             }

           }       

	public function enter_timein()
            {
                $carer_id = $_POST['carer_id'];
                $id = $_POST['id']; 
            	$schedule_id = $_POST['schedule_id'];

            	$started =  $this->carer_model->checkif_started($id,$schedule_id);

            	$status = $started['status'];


                 $this->load->helper('form');
                 $this->load->library('form_validation');

                 $this->form_validation->set_rules('carer_id', 'carer_id', 'trim|required');
                 $this->form_validation->set_rules('id', 'id', 'trim|required');
                 $this->form_validation->set_rules('timein', 'timein', 'trim|required');

        if($status == 0){
                 
                 $this->session->set_flashdata('message1', 'Sorry!..Please Start your task to proceed..');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);

             }    

        elseif ($this->form_validation->run() === FALSE)
                  {
               
                 $this->session->set_flashdata('message1', 'Sorry!..Validation error. Try again with correct values!');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
                 
               

                  }
        else
                  {

                 $this->carer_model->enter_timein();
                 $this->carer_model->set_timeintask($carer_id,$id,$schedule_id);
                 $this->session->set_flashdata('message', 'Check In Successful..');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
				 
                 
                  }
            }

    public function enter_timeout()
            {
                $carer_id = $_POST['carer_id'];
                $id = $_POST['id'];
            	$schedule_id = $_POST['schedule_id'];

            	$started =  $this->carer_model->checkif_started($id,$schedule_id);
            	$completed =  $this->carer_model->checkif_completed($id,$schedule_id);

            	 $status = $started['status'];
                 $actimein = $started['actimein'];


                 $this->load->helper('form');
                 $this->load->library('form_validation');

                 $this->form_validation->set_rules('carer_id', 'carer_id', 'trim|required');
                 $this->form_validation->set_rules('schedule_id', 'schedule_id', 'trim|required');
                 $this->form_validation->set_rules('timeout', 'timeout', 'trim|required');

        if($actimein == NULL OR $status == 0 OR $status == 1){
                 
                 $this->session->set_flashdata('message1', 'Sorry!..Please Ensure you have Checked In and Completed your task(s) to enter time out..');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);

             }   

        elseif ($this->form_validation->run() === FALSE)
                  {
               
                 $this->session->set_flashdata('message1', 'Sorry!..Validation error. Try again with correct values!');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
                 
               

                  }
        else
                  {

                 $this->carer_model->enter_timeout();
                 $this->carer_model->set_timeouttask($carer_id,$id,$schedule_id);
                 $this->session->set_flashdata('message', 'Check Out Successful..');
                 redirect(base_url()."index.php/carerapp/get_scheduleinfo/".$id."/".$schedule_id);
				 
                 
                  }
            }        






	public function logout() 
		{
        $data = ['id_user', 'username'];
        $this->session->sess_destroy($data);
 
        redirect('welcome/index');
        }


}
